﻿package com{
	import flash.display.MovieClip;
	import flash.utils.getDefinitionByName;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Rectangle;

	public class main extends MovieClip {
		
		private var stageMc:MovieClip;
		private var dupContainer:MovieClip;
		private var objectClass:Class;
		private var objectVal:Array=[1000,100,10,1];
		private var totalObjects:Number;
		private var currObject=null;

		public function main() {
			stageMc=this;
			init();
		}

		private function init() {
			feedback.visible=false;
			dupContainer = new MovieClip();
			stageMc.addChild(dupContainer);
			for (var i=1; i<=4; i++) {
				stageMc["object"+i].num=i;
				stageMc["object"+i].val=objectVal[i-1];
				stageMc["object"+i].addEventListener(MouseEvent.MOUSE_DOWN, onPressObject);
			}
			object1.visible = false;
			//stageMc.stage.focus=myTxt;
			myTxt.addEventListener(Event.CHANGE, onInputChange);
			deleteBtn.addEventListener(MouseEvent.CLICK, deleteObject);
			bgMc.addEventListener(MouseEvent.CLICK, onPressBg);
			reset_btn.buttonMode=true;
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);			
			showThoBtn.addEventListener(MouseEvent.CLICK, fnShowHide1000);
			showThoBtn.buttonMode=true;
		}
		
		private function onInputChange(evt:Event){
			validateAnswers();
		}
		
		private function validateAnswers(){
			//trace("read");
			totalObjects=0;
			for(var i=0; i<dupContainer.numChildren; i++){
				var myObject=dupContainer.getChildAt(i);
				totalObjects += myObject.val;
			}
			if(myTxt.text.length>0){
				if(Number(myTxt.text)==totalObjects){
					feedback.visible=true;
				}else{
					feedback.visible=false;
				}
			}else{
				feedback.visible=false;
			}
		}

		private function onPressObject(obj:MouseEvent) {
			objectClass=getDefinitionByName("dragObject"+obj.currentTarget.num) as Class;
			var myObject =new objectClass();
			dupContainer.addChild(myObject);
			resetContainer();
			myObject.val=obj.currentTarget.val;
			myObject.x=obj.currentTarget.x;
			myObject.y=obj.currentTarget.y;
			myObject.gotoAndStop(2);
			myObject.mouseChildren = false;
			myObject.doubleClickEnabled = true;
			myObject.addEventListener(MouseEvent.MOUSE_DOWN, onDownObject);
			myObject.addEventListener(MouseEvent.MOUSE_UP, onUpObject);
			myObject.addEventListener(MouseEvent.DOUBLE_CLICK, onDoubleClick)
			myObject.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));
			validateAnswers();
		}
		private function onDoubleClick(e:MouseEvent)
		{
			var mc:MovieClip = MovieClip(e.currentTarget);
			deleteBtn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
		}
		private function resetContainer(){
			for(var i=0; i<dupContainer.numChildren; i++){
				var myObject=dupContainer.getChildAt(i);
				myObject.gotoAndStop(1);
			}
		}
		
		private function onPressBg(obj:MouseEvent){
			resetContainer();
			currObject=null;
		}
		
		private function deleteObject(obj:MouseEvent){
			if(currObject!=null){
				dupContainer.removeChild(currObject);
				validateAnswers();
			}
		}
		
		private function fnShowHide1000(eve:MouseEvent):void{
			if(showThoBtn.currentFrame == 1)
			{
				showThoBtn.gotoAndStop(2);
				object1.visible = true;
				thousandFun(true);
			}
			else
			{
				showThoBtn.gotoAndStop(1);
				object1.visible = false;
				thousandFun(false)
			}
			
		}
		
		private function thousandFun(bol:Boolean)
		{
			for(var i=0; i<dupContainer.numChildren; i++)
			{
				if(MovieClip(dupContainer.getChildAt(i)).val == 1000)
				{
					var myObject = dupContainer.getChildAt(i);
					myObject.gotoAndStop(1);
					myObject.visible = bol;
				}
			}
		}
		
		private function onReset(obj:MouseEvent){
			while(dupContainer.numChildren){
				dupContainer.removeChildAt(0);
			}
			feedback.visible=false;
			currObject=null;
			myTxt.text="";
			//stageMc.stage.focus=myTxt;
		}
		
		private function onDownObject(obj:MouseEvent){
			currObject=obj.currentTarget;
			currObject.startDrag(false, new Rectangle(50, 100, 650, 300));
			currObject.parent.stage.addEventListener(MouseEvent.MOUSE_UP, onUpObject);
		}
		
		private function onUpObject(obj:MouseEvent){
			currObject.stopDrag();
			resetContainer();
			currObject.gotoAndStop(2);
			currObject.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, onUpObject);
		}
	}
}