﻿package com{
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.utils.getDefinitionByName;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.utils.setTimeout;
	import flash.utils.Timer
	import flash.events.TimerEvent;
	import flash.geom.Rectangle;
	
	public class counterA extends MovieClip{
		private var randomNum:Number;
		private var countersMC:MovieClip;
		private var cntPosArr:Array = [];
		private var groupX:Number = 39;
		private var groupY:Number = 70;
		var groupMCArr:Array = new Array();
		var groupByArr:Array = [20,10,5,2,1];
		var groupMC:MovieClip = new MovieClip;
		var greatMC:great_mc = new great_mc;
		var groupCnt:Number = 0;
		var myTimer:Timer=new Timer(20)
		
		public function counterA():void{
			
			randomNum = Math.ceil(Math.random() * 50) + 50; //generate random number for total counter
			trace("randomNum: " + randomNum)
			entNo_mc.visible = false;
			
			myTimer.addEventListener(TimerEvent.TIMER,runOnce);
			myTimer.start()
			totCnt_txt.addEventListener(Event.CHANGE, fnTotCntTxtChange);
			addChild(groupMC);
			addChild(greatMC);
			greatMC.x = 760/2 - greatMC.width/2;
			greatMC.y = 18;
			greatMC.visible = false;
			fnGenerateCounters();
			fnAddEventsForBtn();
		}
		
		private function runOnce(e:TimerEvent)
		{myTimer.removeEventListener(TimerEvent.TIMER,runOnce);
			myTimer.stop()
			
			stage.stageFocusRect = false;
			stage.focus = totCnt_txt;
			
		}
		
		
		//Validating text entered for rite answer
		private function fnTotCntTxtChange(eve:Event):void{
			if(Number(eve.target.text) == randomNum){
				greatMC.visible = true;				
			}else{
				greatMC.visible = false;	
			}
		}
		
		//Generate counters
		private function fnGenerateCounters():void{
			cntPosArr = [];
			var rowCount:Number = 10;
			var colCount:Number = Math.ceil(randomNum/rowCount);
			var counter:Number = 1;
			var counterClip:counter_mc = new counter_mc;
			var X:Number = 693;
			var Y:Number = 72;
			var XValue:Number;
			countersMC = new MovieClip();
			addChild(countersMC);
			for(var col:Number = 1; col <= colCount; col++){
				XValue = X;
				for(var row:Number = 1; row <= rowCount; row++){					
					counterClip = new counter_mc;
					countersMC.addChild(counterClip);
					counterClip.mouseChildren = false;
					counterClip.x = XValue;
					counterClip.y = Y;
					cntPosArr.push(XValue + "_" + Y);
					counterClip.name = "counter_" + counter;
					counterClip.addEventListener(MouseEvent.MOUSE_DOWN,dragMe);
					counter++;
					if(counter > randomNum){
						break; //breaks the loop whn total count is reached
					}
					Y = Y + counterClip.height + 9;
					if(row%2 != 0){
						XValue = X + counterClip.width - 10;						
					}else{						
						XValue = X;
					}
					
				}
				X = X - counterClip.width - 15;
				Y = 72;
			}
			
		}
		
		private function dragMe(e:MouseEvent):void{
			var currentMovie=e.target;
			currentMovie.startDrag(false,new Rectangle(0,0,760-currentMovie.width,530-currentMovie.width));
			countersMC.setChildIndex(currentMovie,countersMC.numChildren-1);
			currentMovie.addEventListener(MouseEvent.MOUSE_UP,dropMe);
			stage.addEventListener(MouseEvent.MOUSE_UP,dropMe);
		}
		
		private function dropMe(e:MouseEvent):void{
			var currentMovie=e.target;
			currentMovie.stopDrag();
			currentMovie.removeEventListener(MouseEvent.MOUSE_UP,dropMe);
			stage.removeEventListener(MouseEvent.MOUSE_UP,dropMe);
		}
		
		//add events for buttons
		private function fnAddEventsForBtn():void{
			randomNoBtn.addEventListener(MouseEvent.CLICK, reset);
			setNumBtn.addEventListener(MouseEvent.CLICK, fnInputCount);
			group_1_btn.addEventListener(MouseEvent.CLICK, fnAddGroupCounters);
			group_2_btn.addEventListener(MouseEvent.CLICK, fnAddGroupCounters);
			group_5_btn.addEventListener(MouseEvent.CLICK, fnAddGroupCounters);
			group_10_btn.addEventListener(MouseEvent.CLICK, fnAddGroupCounters);
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
		}
		
		//Groups the counters based on group selected
		private function fnAddGroupCounters(eve:MouseEvent):void{
			var btnName:Array = eve.target.name.split("_");
			var mcName:String = "count_" + btnName[1] + "_mc"			
			var removeChildLen:Number = countersMC.numChildren - Number(btnName[1]); //length for removing counters
			if(removeChildLen >= 0){
				var groupClip:*;
				var clip:Class = getDefinitionByName(mcName) as Class;
				groupClip = new clip;
				groupCnt++;
				groupClip.name = "count_" + btnName[1] + "_" + groupCnt;
				groupMC.addChild(groupClip);
				groupClip.addEventListener(MouseEvent.CLICK, fnRemoveGroupCounter);
				groupMCArr.push(groupClip.name);	//adds group name to array, this array is used for aligning each and every time user add group
				fnAlignGroupCounter();
				//removes counters based on group range clicked
				for(var i = countersMC.numChildren; i >  removeChildLen; i--){
					countersMC.removeChild(countersMC.getChildByName("counter_" + i));
				}
			}
		}
		
		//Remove group range counter and add counters back
		private function fnRemoveGroupCounter(eve:MouseEvent):void{	
			for(var i:Number = 0; i < groupMCArr.length; i++){			
				if(groupMCArr[i] == eve.target.name){
					groupMC.removeChild(groupMC.getChildByName(eve.target.name));
					groupMCArr.splice(i,1);
					eve.target.removeEventListener(MouseEvent.CLICK,fnRemoveGroupCounter);
					fnAlignGroupCounter();
					var addCntLen:Number = countersMC.numChildren + Number(eve.target.name.split("_")[1]);
					var counterClip:counter_mc = new counter_mc;
					for(var cntr:Number = countersMC.numChildren + 1; cntr <= addCntLen; cntr++){
						counterClip = new counter_mc;
						countersMC.addChild(counterClip);
						counterClip.x = cntPosArr[cntr - 1].split("_")[0];
						counterClip.y = cntPosArr[cntr - 1].split("_")[1];
						counterClip.name = "counter_" + cntr;
					}
				}
			}
			
		}
		//Group range counter alignment
		private function fnAlignGroupCounter():void{
			var groupClip:MovieClip;
			groupX = 39;
			groupY = 70;
			for(var i = 0; i < groupByArr.length; i++){
				for(var j = 0; j < groupMCArr.length; j++){
					var clipName:Array = groupMCArr[j].split("_");
					if(Number(clipName[1]) == Number(groupByArr[i])){
						groupClip = groupMC.getChildByName(groupMCArr[j]) as MovieClip;
						groupClip.x = groupX;
						groupClip.y = groupY;
						groupY = groupY + groupClip.height + 1;
						if((Number(clipName[1]) == 2 && groupY >= 366) ||(groupY >= 399)){
							groupY = 70;
							groupX = groupX + groupClip.width + 7;
						}
					} 
				}
			}
		}
		
		//Hide/unhide text input of counters to display
		private function fnInputCount(eve:MouseEvent = null):void{
			if(entNo_mc.visible){
				entNo_mc.visible = false;
				entNo_mc.input_txt.text = "";
				entNo_mc.set_btn.removeEventListener(MouseEvent.CLICK, fnGenerateInpCount)
			}else{
				entNo_mc.visible = true;
				entNo_mc.set_btn.addEventListener(MouseEvent.CLICK, fnGenerateInpCount);
			}
		}
		
		//Generate counters based on input value
		private function fnGenerateInpCount(eve:MouseEvent):void{
			var txt:Number = Number(entNo_mc.input_txt.text);
			if(!isNaN(txt) && txt > 0 && txt <= 100 && entNo_mc.input_txt.text != "") {
				randomNum = txt;
				fnReset();
				fnInputCount();
			}
		}
		
		private function fnReset():void{
			RemoveChildOf(groupMC);
			groupCnt = 0;
			groupMCArr = [];
			RemoveChildOf(countersMC);
			fnGenerateCounters();			
			totCnt_txt.text = "";
			greatMC.visible = false;
			stage.focus = totCnt_txt;
		}
		
		//Generates counters randomly
		private function reset(eve:MouseEvent):void{
			randomNum = Math.ceil(Math.random() * 50) + 50;
			fnReset();
		}
		
		//Removes children of reference movie clip
		private function RemoveChildOf(Reference:*):void
		{
			for(var s:int=Reference.numChildren-1;s>=0;s--)
			{
				Reference.removeChild(Reference.getChildAt(s));
			}
			
		}
	}
}