﻿package com{
	
	import flash.display.MovieClip;	
	import flash.utils.getDefinitionByName;
	import flash.geom.Rectangle;
	import flash.events.MouseEvent;	
	
	public class sortCoins extends MovieClip{
		private var coinsMC:MovieClip = new MovieClip();
		private var draggedCoin:MovieClip;
		
		private var coins:String = "fiveC_H_mc,fiveC_T_mc,tenC_H_mc,tenC_T_mc,twentyC_H_mc,twentyC_T_mc,fiftyC_H_mc,fiftyC_T_mc,oneD_H_mc,oneD_T_mc,twoD_H_mc,twoD_T_mc";
		private var coinsArr:Array = [];
		private var shuffledCoinsArr:Array = [];
		private var coinsPosArr:Array = [];
		private var dropTarArr:Array = ["fiveC_drop_mc", "tenC_drop_mc", "twentyC_drop_mc", "fiftyC_drop_mc", "oneD_drop_mc", "twoD_drop_mc"];
		private var dropPosArr:Array = [];
		private var stageWidth:Number = 760;
		private var coinsXPos:Number = 0;
		private var coinsYPos:Number = 458;
		private var coinCnt:Number = 1;
		private var droppedCoinCnt:Number = 0;
		
		public function sortCoins():void
		{
			addChild(coinsMC);
			fnArrayShuffle();
			fnDisplayCoins();
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
			reset_btn.mouseChildren = false;
			reset_btn.buttonMode = true;
			for(var i:Number = 0; i < dropTarArr.length; i++)
			{
				var dropTarClip:MovieClip = getChildByName(dropTarArr[i]) as MovieClip;
				dropTarClip.cnt = [null, null];
				dropPosArr.push(dropTarClip.x + "_" + dropTarClip.y);
				
			}
			
		}
		
		//shuffles coin array for displaying coins in random position
		private function fnArrayShuffle():void{
			coinsArr = [];
			coinsArr = coins.split(",");
			shuffledCoinsArr = []; 
			while(coinsArr.length > 0) 
			{
				shuffledCoinsArr.push(coinsArr.splice(Math.round(Math.random() * (coinsArr.length - 1)), 1)[0]);
			}
		}
		
		//displays coins on stage
		private function fnDisplayCoins():void
		{
			var clipClass:Class;
			var clipMC:MovieClip;
			for(var i:Number = 0; i < shuffledCoinsArr.length; i++)
			{
				clipClass = getDefinitionByName(shuffledCoinsArr[i]) as Class;
				clipMC = new clipClass();
				clipMC.hitMc = null;
				coinsMC.addChild(clipMC);
				clipMC.name = shuffledCoinsArr[i];
				clipMC.x = (105 * coinCnt);
				clipMC.y = coinsYPos;
				clipMC.correct = 0;
				coinsPosArr.push(clipMC.x+"_"+clipMC.y);
				coinCnt++;
				if(coinCnt == 7)
				{
					coinCnt = 1;
					coinsYPos = 348;
				}
				//adding events for coin
				clipMC.buttonMode = true;
				clipMC.addEventListener(MouseEvent.MOUSE_DOWN, fnMouseDownCoin);
				clipMC.mouseChildren = false;
			}
		}
		private function fnMouseDownCoin(eve:MouseEvent):void{
			var clipMC:MovieClip = eve.target as MovieClip;
			clipMC.addEventListener(MouseEvent.MOUSE_MOVE, fnStartDragCoin);
			clipMC.addEventListener(MouseEvent.MOUSE_UP, fnStopDragCoin);
			if(clipMC.hitMc != null)
			{
				if(clipMC.correct == 1)
				{
					droppedCoinCnt--;
					clipMC.correct = 0;
					trace("minus "+droppedCoinCnt)
				}
				trace("index "+clipMC.hitMc.cnt.indexOf(clipMC))
				clipMC.hitMc.cnt[clipMC.hitMc.cnt.indexOf(clipMC)] = null;
				clipMC.hitMc = null;
			}
						
		}
		private function fnStartDragCoin(eve:MouseEvent):void
		{
			draggedCoin = eve.currentTarget as MovieClip;
			 eve.target.parent.setChildIndex(draggedCoin, (draggedCoin.parent.numChildren-1));
			 eve.target.startDrag(true, new Rectangle(10, 10, 690, 460));// drag area restriction										
		}
		
		//When coin dragged, mouseX and mouseY is checked whether it is with the drop target range. If it is within drop area target range, coin is placed on the respective drop area. Coin is dropped on drop target area only when dragged coin value and drop target area money value are same. If drop target money value and dragged coin value are not same it is returned to the original position. When another coin from original pool of coins while dragging, clicked coin will be attached to the mouse cursor and dragged coin will reset to its original position and events are removed. 
		private function fnStopDragCoin(eve:MouseEvent):void
		{
			var dragClip:MovieClip = eve.currentTarget as MovieClip;
			var hitted:Boolean = false;
			dragClip.removeEventListener(MouseEvent.MOUSE_MOVE, fnStartDragCoin);
			dragClip.removeEventListener(MouseEvent.MOUSE_UP, fnStopDragCoin);
			
			if(dragClip.dropTarget !== null && String(dragClip.dropTarget) != "[object Bitmap]")
			{
				var dropTar:String = dragClip.dropTarget.parent.name;
				var dropClip:MovieClip;
				for(var i:Number = 0; i < dropPosArr.length; i++)
				{
					var dropTarEndX:Number = Number(dropPosArr[i].split("_")[0]) + fiveC_drop_mc.width;
					var dropTarEndY:Number = Number(dropPosArr[i].split("_")[1]) + fiveC_drop_mc.height;
					if(mouseX >=  Number(dropPosArr[i].split("_")[0]) && mouseX <=  dropTarEndX && mouseY >=  Number(dropPosArr[i].split("_")[1]) && mouseY <=  dropTarEndY)
					{
						dropClip = getChildByName(dropTarArr[i]) as MovieClip;
						dragClip.stopDrag();
						var count:int = 0;
						var place:int = 0;
						for(var k = 0; k< dropClip.cnt.length; k++)
						{
							if(dropClip.cnt[k] == null)
							{
								count++;
							}
						}
						
						if(count <= 0)
						{
							//trace("dropClip.cnt[1] "+dropClip.cnt[1].name)
							fnReturnDrag2OrgPos(dropClip.cnt[1]);
							if(dropClip.cnt[1].correct == 1)
							{
								droppedCoinCnt--;
								dropClip.cnt[1].correct = 0;
							}
							dropClip.cnt[1] = null;
							count = 2;
						}
						place = dropClip.cnt.indexOf(null) + 1;
						//trace("null "+place)
						dropClip.cnt[place-1] = dragClip;
						dragClip.hitMc = dropClip;
						dragClip.x = dropClip.x + dropClip.width/2;
						var dropYHei:Number = (dropClip.y + dropClip.height)/(3 - place);
						dragClip.y = dropYHei - 35 - (30 * (place -1));
						dragClip.removeEventListener(MouseEvent.MOUSE_MOVE, fnStartDragCoin);
						dragClip.removeEventListener(MouseEvent.MOUSE_UP, fnStopDragCoin);
						hitted = true;
						if(dragClip.name.split("_")[0] == dropTarArr[i].split("_")[0])
						{
							droppedCoinCnt++;
							dragClip.correct = 1;
							trace("drag correct mc "+droppedCoinCnt)
							break;
						}
					}
				}
			}
			
			if(!hitted)
			{
				fnReturnDrag2OrgPos(dragClip);
			}
			if(droppedCoinCnt == shuffledCoinsArr.length)
			{
				if(getChildByName("greatMC") != null)
				{
					removeChild(getChildByName("greatMC"));
				}
				var greatMC:great_mc = new great_mc();
				addChild(greatMC);
				greatMC.name = "greatMC";
				greatMC.x = stageWidth/2;
				greatMC.y = 400;
				coinsMC.mouseChildren = false;
				coinsMC.mouseEnabled = false;
			}
			else
			{
				if(getChildByName("greatMC") != null)
				{
					removeChild(getChildByName("greatMC"));
				}
				if(findAllPlaced())
				{
					var greatMC2:great_mc = new great_mc();
					addChild(greatMC2);
					greatMC2.name = "greatMC";
					greatMC2.x = stageWidth/2;
					greatMC2.y = 400;
					greatMC2.gotoAndStop(2)
				}
			}
		}
		
		private function findAllPlaced():Boolean
		{
			var dropClip:MovieClip;
			for(var i:Number = 0; i < dropPosArr.length; i++)
			{
				dropClip = getChildByName(dropTarArr[i]) as MovieClip;
				if(dropClip.cnt.indexOf(null) != -1)
				{
					return false;
				}
			}
			return true;
		}
		//returns the coin to its original position
		private function fnReturnDrag2OrgPos(clip:MovieClip):void{
			for(var ii:Number = 0; ii < shuffledCoinsArr.length; ii++)
			{
				var orgCoinClip:MovieClip = coinsMC.getChildByName(shuffledCoinsArr[ii]) as MovieClip;
				if(clip.name == orgCoinClip.name){
					clip.stopDrag();
					clip.x = Number(coinsPosArr[ii].split("_")[0]);
					clip.y = Number(coinsPosArr[ii].split("_")[1]);	
					break;
				}
			}
		}
		
		//removes children of reference clip
		private function removeChildOf(clip:*):void
		{
			for(var i:Number = clip.numChildren-1; i >= 0; i--){
				clip.removeChild(clip.getChildAt(i));
			}
		}
		
		private function reset(eve:MouseEvent):void{
			removeChildOf(coinsMC);
			coinsMC.mouseChildren = true;
			coinsMC.mouseEnabled = true;
			coinsYPos = 458;
			coinCnt = 1;
			coinsPosArr = [];
			for(var i:Number = 0; i < dropTarArr.length; i++)
			{
				var dropTarClip:MovieClip = getChildByName(dropTarArr[i]) as MovieClip;
				dropTarClip.cnt = [null, null];;
			}
			droppedCoinCnt = 0;
			if(getChildByName("greatMC") != null)
			{
				removeChild(getChildByName("greatMC"));
			}
			fnArrayShuffle();
			fnDisplayCoins();			
		}
	}
}