﻿package com{

	import flash.display.MovieClip;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;

	public class main extends MovieClip {

		private var stageMc:MovieClip;
		private var target1Cont:MovieClip;
		private var dragObject:MovieClip=null;
		private var diceClass:Class;
		private var duplicateClip:MovieClip;
		private var dupInde:int=0;
		private var rndDice1:int;
		private var rndDice2:int;
		private var dropItem1:int=0;

		public function main() {
			stageMc=this;
			reset_btn.buttonMode=true;
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			stageMc.addEventListener(MouseEvent.MOUSE_DOWN, onMousePress);
			init();
		}

		private function init() {
			for (var j:int=1; j<=12; j++) {
				this["object"+j].indexNum=j;
			}

			rndDice1=(Math.floor(Math.random()*6))+1;
			rndDice2=(Math.floor(Math.random()*6))+1;

			for (var i:int=1; i<=2; i++) {
				//diceClass=getDefinitionByName(getQualifiedClassName(stageMc["object"+this["rndDice"+i]])) as Class;
				diceClass=getDefinitionByName("dice"+this["rndDice"+i]) as Class;
				duplicateClip=new diceClass();
				stageMc.addChild(duplicateClip);
				target1["dup"+dupInde]=duplicateClip;
				duplicateClip.x=stageMc["base"+i].x;
				duplicateClip.y=stageMc["base"+i].y;
				//duplicateClip.gotoAndStop(stageMc["object"+this["rndDice"+i]].currentFrame);
				dupInde++;
			}

		}

		private function onMousePress(obj:MouseEvent) {
			for (var j:int=1; j<=12; j++) {
				if (mouseX>=this["object"+j].x-(this["object"+j].width/2)
				&&mouseX<=this["object"+j].x+(this["object"+j].width/2)
				&&mouseY>=this["object"+j].y-(this["object"+j].height/2)
				&&mouseY<=this["object"+j].y+(this["object"+j].height/2)) {
					dragFunction(this["object"+j] as MovieClip);
				}
			}
		}

		private function dragFunction(mov:MovieClip) {

			diceClass=getDefinitionByName(getQualifiedClassName(mov)) as Class;
			duplicateClip=new diceClass();
			stageMc.addChild(duplicateClip);

			target1["dup"+dupInde]=duplicateClip;
			if (dragObject!=null) {
				//removeChild(dragObject);
				dragObject.visible=false;
			}
			duplicateClip.x=mov.x;
			duplicateClip.y=mov.y;
			duplicateClip.startDrag(true,new Rectangle(70, 70, 620, 410));

			dragObject=duplicateClip as MovieClip;
			duplicateClip.indexNum=mov.indexNum;
			duplicateClip.addEventListener(MouseEvent.MOUSE_UP,dropFunction);
			dupInde++;
		}

		private function dropFunction(e:MouseEvent) {
			for (var i:int=1; i<=1; i++) {
				if (e.currentTarget.hitTestObject(stageMc["target"+i])) {
					e.currentTarget.stopDrag();

					if (this["target"+i+"Cont"]!==null) {
						//removeChild(this["target"+i+"Cont"]);
						this["target"+i+"Cont"].visible=false;
					}
					//trace("dragObject = "+dragObject);
					this["dropItem"+i]=e.currentTarget.indexNum;
					if(dragObject==null){
						this["dropItem"+i]=0;
					}
					dragObject=null;
					e.currentTarget.x=stageMc["target"+i].x;
					e.currentTarget.y=stageMc["target"+i].y;
					this["target"+i+"Cont"]=e.currentTarget as MovieClip;
				}
			}
			if (dropItem1==(rndDice1+rndDice2)) {
				feedBackMc.gotoAndStop("correct");
			} else if (dropItem1!=0) {
				feedBackMc.gotoAndStop("wrong");
			}else{
				feedBackMc.gotoAndStop(1);
			}
		}

		private function onReset(obj:MouseEvent) {
			for (var i:int=0; i<dupInde; i++) {
				if (target1["dup"+i]!=null) {
					removeChild(target1["dup"+i]);
					//target1["dup"+i]=null;
				}
			}
			dragObject=null;
			target1Cont=null;
			dropItem1=0;
			dupInde=0;
			feedBackMc.gotoAndStop(1);
			init();
		}

	}
}