﻿package com{
	import flash.display.MovieClip;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.utils.getDefinitionByName;
	import flash.text.TextFieldType;
	public class ladyBird extends MovieClip{
		
		private var xml:XML = new XML();
		private var ranN:Number = 0;
		private var leafCnt:Number = 0;
		private var beesArr:Array = new Array();
		private var noOfBees:Number = 0;
		private var totNumOfBees:Number = 0;
		private var textCorrect:Boolean = false;
		private var birdCorrect:Boolean = false;
		
		public function ladyBird() {
			var urlLoader:URLLoader = new URLLoader();
			urlLoader.load(new URLRequest("xml/content.xml"));
			urlLoader.addEventListener(Event.COMPLETE, fnXMLLoadComp);
			feedBack.visible = false;
			txt1.text=txt2.text=txt3.text="";
			txt1.type = TextFieldType.INPUT;
			txt2.type = TextFieldType.INPUT;
			txt3.type = TextFieldType.INPUT;
			txt1.addEventListener(Event.CHANGE, changeText);
			txt2.addEventListener(Event.CHANGE, changeText);
			txt3.addEventListener(Event.CHANGE, changeText);
		}
		private function changeText(e:Event)
		{
			trace(noOfBees+" : "+leafCnt+" : "+noOfBees/leafCnt);	
			trace((Number(txt1.text)==noOfBees)+" : "+(Number(txt2.text)==leafCnt)+" : "+(Number(txt3.text)==noOfBees/leafCnt));	
			
			textCorrect = false;
			if((txt1.text!="") && (txt2.text!="") && (txt3.text!=""))
			{
				feedBack.visible=true;
				if((Number(txt1.text)==noOfBees) && (Number(txt2.text)==leafCnt) && (Number(txt3.text)==noOfBees/leafCnt))
				{
					textCorrect = true;
					displayAnswer();
					/*txt1.type = TextFieldType.DYNAMIC;
					txt2.type = TextFieldType.DYNAMIC;
					txt3.type = TextFieldType.DYNAMIC;
					for(var i = 0; i < noOfBees; i++)
					{
						var bee:MovieClip = getChildByName("bees"+i) as MovieClip;
						bee.buttonMode = false;
						bee.removeEventListener(MouseEvent.MOUSE_DOWN, dragBee);
						
					}
					feedBack.gotoAndStop(1);*/
				}
				else 
				{
					
					feedBack.gotoAndStop(2);
				}
			}
			else
			{
				feedBack.gotoAndStop(2);
			}
			
		}
		
		private function displayAnswer()
		{
			if(textCorrect && birdCorrect)
			{
				txt1.type = TextFieldType.DYNAMIC;
				txt2.type = TextFieldType.DYNAMIC;
				txt3.type = TextFieldType.DYNAMIC;
				for(var i = 0; i < noOfBees; i++)
				{
					var bee:MovieClip = getChildByName("bees"+i) as MovieClip;
					bee.buttonMode = false;
					bee.removeEventListener(MouseEvent.MOUSE_DOWN, dragBee);
				}
				trace("removed listeners")
				feedBack.gotoAndStop(1);
			}
			else 
			{
				feedBack.gotoAndStop(2);
			}
		}
		
		private function fnXMLLoadComp(e:Event):void
		{
			xml = XML(e.target.data);
			reset_btn.addEventListener(MouseEvent.CLICK, fnReset);
			fnGenerateRandNum();
		}
		
		private function fnGenerateRandNum():void
		{
			ranN = Math.floor(Math.random()*(3));
			leafCnt = xml.leaf.bees[ranN].@leafCnt;
			beesArr = xml.leaf.bees[ranN].@beasCnt.split(",");
			fnGenerateLeavesBees();
		}
		
		private function fnGenerateLeavesBees():void
		{	
			for(var i:Number = 0; i < leafCnt; i++)
			{
				var leavesMC:leaves = new leaves();
				addChild(leavesMC);
				leavesMC.x = xml.leafPos.position[ranN].pos[i].@xPos;
				leavesMC.y = xml.leafPos.position[ranN].pos[i].@yPos;
				leavesMC.name = "leaves"+i;
				leavesMC.beesCnt = 0;
				leavesMC.posArr = new Array()
			}
			
			var ran:Number = Math.floor(Math.random()*(beesArr.length));
			noOfBees = beesArr[ran];
			totNumOfBees=noOfBees;	
			var xPos:Number=150+(40*((12-noOfBees)/2))
				
			for(i=0; i<noOfBees;i++)
			{
				var beeClass:Class=getDefinitionByName("bee") as Class;
				var beeMc:MovieClip=new beeClass as MovieClip;
				addChild(beeMc);
				beeMc.x=beeMc.xPos=xPos;
				beeMc.buttonMode=true;
				beeMc.name="bees"+i;
				xPos=xPos+40;
				beeMc.y=beeMc.yPos=458;
				beeMc.leaf = null;
				beeMc.addEventListener(MouseEvent.MOUSE_DOWN, dragBee);
				beeMc.addEventListener(MouseEvent.MOUSE_UP, dropBee);
			}
			
		}
		
		private function repostion(mc)
		{
			var ind:int = 0;
			for(var i = 0; i < noOfBees; i++)
			{
				var bee:MovieClip = getChildByName("bees"+i) as MovieClip;
				if(bee.leaf == mc)
				{
					bee.x = (mc.x - mc.width/2) + Number(xml.beesPos.position.pos[ind].@xPos);
					bee.y = (mc.y - mc.height/2) + Number(xml.beesPos.position.pos[ind].@yPos);
					ind ++;
				}
			}
		}
		
		private function dragBee(e:MouseEvent)
		{	
			this.setChildIndex(MovieClip(e.target), (this.numChildren - 1));
			e.target.startDrag();
			if(MovieClip(e.target).leaf != null)
			{
				MovieClip(e.target).leaf.beesCnt--;
				totNumOfBees++;
				MovieClip(e.target).leaf = null;
			}
		}
		
		private function dropBee(e:MouseEvent)
		{
			e.target.stopDrag();
			var flag:Boolean = false;
			birdCorrect = false; 
			for(var i:Number = 0; i < leafCnt; i++)
			{
				var mc:MovieClip;
				mc = getChildByName("leaves"+i) as MovieClip;
				if(e.target.hitTestObject(mc))
				{
					var ind:Number = mc.beesCnt;
					e.target.x = (mc.x - mc.width/2) + Number(xml.beesPos.position.pos[ind].@xPos);
					e.target.y = (mc.y - mc.height/2) + Number(xml.beesPos.position.pos[ind].@yPos);
					mc.beesCnt++;
					totNumOfBees--;
					//e.target.mouseEnabled=false;
					flag = true;
					MovieClip(e.target).leaf = mc;
					repostion(mc)
					break;
				}
			}
			if(!flag)
			{
				e.target.x=e.target.xPos;
				e.target.y=e.target.yPos;
			}
			if(totNumOfBees == 0)
			{	
				//feedBack.visible=true;
				flag = true;
				for(i = 0; i < leafCnt; i++)
				{
					mc = new MovieClip();
					mc = getChildByName("leaves" + i) as MovieClip;
					if(mc.beesCnt == noOfBees/leafCnt)
					{
						
						flag = true;
					}
					else
					{
						flag = false;
						break;
					}
				}
				if(flag)
				{
					birdCorrect = true;
					displayAnswer();
				}
				/*if(flag)
				{
					txt1.text=String(noOfBees);					
					txt2.text=String(leafCnt);
					txt3.text=String(noOfBees/leafCnt);
					//line.visible=false;
					feedBack.gotoAndStop(1);
				}
				else
				{
					feedBack.gotoAndStop(2);
				}*/
			}
		}
		
		private function fnReset(e:MouseEvent)
		{
			textCorrect = false;
			birdCorrect = false;
			var mc:MovieClip;
			for(var i:Number = 0; i < leafCnt; i++){
				mc = getChildByName("leaves"+i) as MovieClip;
				removeChild(mc);
			}
			
			for(i = 0; i < noOfBees; i++){
				mc = getChildByName("bees"+i) as MovieClip;
				removeChild(mc);
			}
			txt1.text="";
			txt2.text="";
			txt3.text="";
			txt1.type = TextFieldType.INPUT;
			txt2.type = TextFieldType.INPUT;
			txt3.type = TextFieldType.INPUT;
			line.visible=true;
			feedBack.visible = false;
			fnGenerateRandNum();
		}

	}
	
}
