﻿package com{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Graphics;

	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;

	import flash.events.Event;
	import flash.events.MouseEvent;

	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	import flash.text.TextFieldAutoSize;
	public class PlaceValue_Millions extends MovieClip {
		private var XMLObj:XML=new XML();
		private var DragObj:MovieClip=new MovieClip();
		private var DropElementsArray:Array=new Array();
		private var DropObjArray:Array;
		private var Counter:Number=0;
		private var RowObjectsArray:Array=new Array();
		private var randomArr:Array = new Array();
		private var droppedObjArr:Array = new Array();

		private var mabButtonVisible=true;

		private var sw:Number=760;
		private var sh:Number=500;
		private var shp:Shape;
		private var ro:Shape;

		private var tb=0;
		private var digitsType:String="random";

		private var tableContainer:MovieClip=new MovieClip();
		private var numContainer:MovieClip=new MovieClip();
		private var dropsContainer:MovieClip=new MovieClip();
		private var rangeContainer:MovieClip=new MovieClip();
		private var mabContainer:MovieClip=new MovieClip();
		private var rCnt:Number=1;
		private var indx:Number=1;
		private var flag:Boolean = true; //flag for generating random numbers elements

		public function PlaceValue_Millions()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void {
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/placeValueMat.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void {
			XMLObj=XML(e.target.data);
			allDigits.visible=true;
			allDigitsSelected.visible=false;
			randomDigits.visible=false;
			randomDigitsSelected.addEventListener(MouseEvent.CLICK, changeDigitType);
			randomDigitsSelected.buttonMode = true;
			randomDigitsSelected.visible=true;
			initialize();
			CreateMab();
		}
		private function initialize() {

			DragObj=new MovieClip();
			Counter=0;
			RowObjectsArray=new Array();
			DropElementsArray=new Array();
			droppedObjArr = new Array();
			CreateTable();
			CreateDrops();
			CreateDrags();
			AddResetBtn();
			randomDigits.addEventListener(MouseEvent.CLICK, changeDigitType);
			allDigits.addEventListener(MouseEvent.CLICK, changeDigitType);
			resetMAB.addEventListener(MouseEvent.CLICK, changeDigitType);
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
			showThoBtn.addEventListener(MouseEvent.CLICK, fnShowHideThousand);

		}

		function changeDigitType(e:MouseEvent) {
			removeDigits();
			if (e.currentTarget.name=="allDigits") 
			{
				digitsType="all";
				allDigits.visible=false;
				allDigitsSelected.visible=true;
				randomDigits.visible=true;
				randomDigitsSelected.visible=false;
				rCnt=Number(XMLObj.Table[tb].Rows.@count);
			} 
			else if (e.currentTarget.name=="randomDigits") 
			{
				digitsType="random";
				allDigits.visible=true;
				allDigitsSelected.visible=false;
				randomDigits.visible=false;
				randomDigitsSelected.visible=true;
				rCnt=1;
			}else if (e.currentTarget.name=="randomDigitsSelected")
			{
				digitsType="randomSel";
				/*allDigits.visible=true;
				allDigitsSelected.visible=false;
				randomDigits.visible=false;
				randomDigitsSelected.visible=true;*/
				rCnt=1;
				flag = true;
			}
			initialize();
			CreateMab();
		}



		private function removeDigits() {
			while (numContainer.numChildren>0) {
				numContainer.removeChildAt(0);
			}
			while (rangeContainer.numChildren>0) {
				rangeContainer.removeChildAt(0);
			}
		}

		private function AddBottomPanel():void {
			var sh:Shape=new Shape();
			var g:Graphics=sh.graphics;
			g.lineStyle(XMLObj.BottomPanel.@linethickness,XMLObj.BottomPanel.@linecolor);
			g.drawRect(0,0,XMLObj.BottomPanel.@width,XMLObj.BottomPanel.@height);
			addChild(sh);
			sh.x=XMLObj.BottomPanel.@xpos;
			sh.y=XMLObj.BottomPanel.@ypos;
		}

		private function fnShowHideThousand(eve:MouseEvent) 
		{
			if (showThoBtn.currentFrame==1) {
				showThoBtn.gotoAndStop(2);
				indx=0;				
			} else {
				indx=1;
				showThoBtn.gotoAndStop(1);				
			}
			if (digitsType=="all") {
				rCnt=Number(XMLObj.Table[tb].Rows.@count);
			}else{
				rCnt = 1;
			}
			RowObjectsArray=new Array();
			DropElementsArray=new Array();
			droppedObjArr = new Array();
			flag = true;
			CreateTable();
			removeDigits();
			CreateDrags();
			CreateDrops();
		}
		private function CreateTable():void {
			resetTable();

			var NumColumns:Number;
			var StartX:Number;
			var StartY:Number;

			NumColumns=XMLObj.Table[tb].Columns1.Column.length();
			StartX=Number(XMLObj.Table[tb].Columns1.@xpos);
			StartY=Number(XMLObj.Table[tb].Columns1.@ypos);
			//////////////////////////Create Number columns///////////////////
			for (var i:int=0; i<NumColumns-indx; i++)
			{

				shp=new Shape();
				shp.name="col1"+tb+i;
				var g:Graphics=shp.graphics;
				tableContainer.addChild(shp);

				g.lineStyle(XMLObj.CommonColumnProperties.@linethickness,XMLObj.CommonColumnProperties.@lineColor);
				g.beginFill(XMLObj.CommonColumnProperties.@headercolor);
				g.drawRect(0,0,XMLObj.Table[tb].Columns1.Column[i].@width,XMLObj.CommonColumnProperties.@headerheight);
				g.endFill();

				var txt=CreateTextField();
				txt.name="txt1"+tb+i;
				tableContainer.addChild(txt);
				if(indx == 1)
				{
					txt.text=XMLObj.Table[tb].Columns1.Column[i+1].@Title;
				}
				else
				{
					txt.text=XMLObj.Table[tb].Columns1.Column[i].@Title;
				}
				txt.x=StartX + (XMLObj.Table[tb].Columns1.Column[i].@width/2 - txt.width/2);
				txt.y=XMLObj.CommonColumnProperties.@headerheight-txt.height/2;
				shp.x=StartX;

				var left:Number=0;
				var top:Number=StartY+27;
				var right:Number=XMLObj.Table[tb].Columns1.Column[i].@width;
				var bottom:Number=XMLObj.CommonColumnProperties.@columnHeight*rCnt;
				g.lineStyle(XMLObj.CommonColumnProperties.@linethickness,XMLObj.CommonColumnProperties.@lineColor);
				g.beginFill(XMLObj.CommonColumnProperties.@fillcolor,1);
				g.drawRect(left,top,right,bottom);
				g.endFill();

				StartX += Number(XMLObj.Table[tb].Columns1.Column[i].@width);
				shp.y=StartY;
			}

			//////////////////Create Number rows and dots///////////////////////
			var rowWidth:Number=StartX-Number(XMLObj.Table[tb].Columns1.@xpos);
			var rowHht:Number=XMLObj.CommonColumnProperties.@columnHeight;
			
			StartX=XMLObj.Table[tb].Columns1.@xpos;
			StartY=Number(XMLObj.Table[tb].Columns1.@ypos)+Number(XMLObj.CommonColumnProperties.@headerheight);
			for (i=0; i<rCnt-1; i++) 
			{
				ro=new Shape();
				ro.name="row1"+tb+i;
				ro.graphics.moveTo(StartX, rowHht);
				ro.graphics.lineStyle(XMLObj.Table[tb].Rows.@linethickness,XMLObj.Table.Rows.@lineColor);
				ro.graphics.lineTo(rowWidth,rowHht);
				tableContainer.addChild(ro);

				ro.x=StartX;
				ro.y=StartY;
				StartY+=rowHht;
			}

			addChild(tableContainer);
			addChild(dropsContainer);
			addChild(rangeContainer);
			addChild(numContainer);
			addChild(mabContainer);
			tableContainer.x=760/2-tableContainer.width/2;
		}

		private function clearObj(tNo,objName,cellType,parentObj) {

			var noOfObj:Number;
			if (cellType=="column")
			{
				noOfObj=XMLObj.Table[tNo].Columns1.Column.length();
			}
			else if (cellType=="row")
			{
				noOfObj=Number(XMLObj.Table[tNo].Rows.@count);
			}
			if (objName=="drop_") {
				noOfObj=7;
			}


			for (var i1=0; i1<noOfObj; i1++) {
				var shapeName:String;
				if (objName=="drop_") 
				{
					shapeName=objName+i1;
				} else 
				{
					shapeName=objName+String(tNo)+i1;
				}
				if (parentObj.getChildByName(shapeName)!=null) {

					parentObj.removeChild(parentObj.getChildByName(shapeName));

				}
			}

		}

		//create drop area for digits
		private function CreateDrops():void 
		{
			clearObj(tb,"drop_","column",dropsContainer);
			DropObjArray=new Array();
			var DropStartX:Number=Number(XMLObj.Table[tb].Columns1.@xpos);
			var DropStartY:Number=Number(XMLObj.Table[tb].Columns1.@ypos) + Number(XMLObj.CommonColumnProperties.@headerheight);
			var DropHeight:Number=Number(XMLObj.CommonColumnProperties.@columnHeight)-Number(XMLObj.CommonColumnProperties.@headerheight);
			var NumColumns_1:Number=XMLObj.Table[tb].Columns1.Column.length();
			var left:Number=0;
			var top:Number=0;
			var right:Number=XMLObj.Table[tb].Columns1.Column[0].@width-2;
			var bottom:Number=XMLObj.CommonColumnProperties.@columnHeight*rCnt;
			trace("bottom ",bottom, rCnt)
			for (var i:int=0; i<NumColumns_1-indx; i++) 
			{				
				var sh:MovieClip=new MovieClip();
				sh.name="drop_"+i;
				sh.index=i;
				sh.graphics.beginFill(0xff0000,0);
				sh.graphics.drawRect(left,top,right,bottom);
				sh.graphics.endFill();
				dropsContainer.addChild(sh);
				
				sh.x=DropStartX-1;
				sh.y=DropStartY;
				trace("aaa "+i)
				DropStartX+=Number(XMLObj.Table[tb].Columns1.Column[i].@width);

				var Obj:Object=new Object();
				Obj.DropsArray=new Array(); //array for saving drags
				Obj.DropsPosArray = new Array(); //array for storing positions
				Obj.DropsRemArray = new Array(); //array for storing removed drag movieclips
				DropElementsArray.push(Obj);
				DropObjArray.push(sh);

				var ins:Object=new Object();
				ins.RowArray=new Array();
				RowObjectsArray.push(ins);
			}
			dropsContainer.x=760/2-dropsContainer.width/2;
		}

		//creates drag movieclip
		private function CreateDrags():void 
		{ 
			var StartNo:Number=Number(XMLObj.Numbers.@range.split("-")[0]);
			var EndNo:Number;
			if (digitsType=="all")
			{
				EndNo=Number(XMLObj.Numbers.@range.split("-")[1]);
			} 
			else 
			{
				EndNo=3 - indx;
			}

			var StartX:Number=Number(XMLObj.Numbers.@xpos);
			var StartY:Number=Number(XMLObj.Numbers.@ypos);
			for (var i:int=StartNo; i<=EndNo; i++)
			{
				var mc:MovieClip;
				if (digitsType=="all") {
					mc=CreateMC(""+i);
					mc.index=i;
					mc.x=StartX+0;
					StartX+=Number(XMLObj.Numbers.@gap)+mc.width;
				}
				else 
				{
					//when flag is true new random numbers are generated. 
					//When it is false drag element is created with the same set of random numbers
					
					var randNum:Number;
					if(flag)
					{
						var randomNumArr:Array = new Array();
						checkRandom();
						function checkRandom()
						{
							randNum=Math.floor(Math.random()*9);	
							for (var rnd=0; rnd<randomArr.length; rnd++) {
								if (randNum==randomArr[rnd]) {
									checkRandom();
								}
							}
							randomArr[i]=randNum;
						}
					}
					else
					{
						randNum = randomArr[i]; 
					}
					mc=CreateMC(""+randNum);
					mc.index=randNum;
					if(i == StartNo)
						StartX = StartX + 0;
					mc.x=StartX+0;
					StartX+=Number(XMLObj.Numbers.@gap)+mc.width+42;
				}
				Counter++;
				rangeContainer.addChild(mc);
				mc.y=StartY;
				mc.xpos=mc.x;
				mc.ypos=mc.y;
				mc.cnt = 0;

				mc.mouseChildren=false;
				mc.buttonMode=true;
				mc.addEventListener(MouseEvent.MOUSE_DOWN,DragIt);
			}
			trace("width "+rangeContainer.x)
			rangeContainer.x = 760/2 - rangeContainer.width/2;
		}

		private function AddResetBtn():void {
			var showMABBtn=getChildByName("showMABBtn");
			showMABBtn.addEventListener(MouseEvent.CLICK, showTable);
		}
		private function showTable(e:MouseEvent) {
			if (showMABBtn.currentFrame==1) {
				CreateMab();
				showMABBtn.gotoAndStop(2);
			} else {
				showMABBtn.gotoAndStop(1);
			}
			toggleMabObj();
		}
		private function resetTable() {
			clearObj(0,"col1","column",tableContainer);
			clearObj(0,"txt1","column",tableContainer);
			clearObj(0,"row1","row",tableContainer);
		}

		private function CreateTextField():TextField {
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.type="dynamic";
			TxtFld.selectable=false;
			TxtFld.border=false;
			TxtFld.autoSize=TextFieldAutoSize.LEFT;

			TxtFld.antiAliasType=AntiAliasType.ADVANCED;

			var TF:TextFormat=new TextFormat();

			var FontC=getDefinitionByName(XMLObj.Words.@FontId) as Class;
			var newFont:Font=new FontC();

			TF.font=newFont.fontName;
			TF.align="center";
			TF.size=XMLObj.Words.@FontSize;
			TF.color=XMLObj.Words.@FontColor;

			TxtFld.defaultTextFormat=TF;
			TxtFld.embedFonts=true;
			return TxtFld;

		}
		private function CreateMC(Str:String):MovieClip {
			var mc:MovieClip=new MovieClip();
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.autoSize="left";
			TxtFld.htmlText=Str;
			TxtFld.selectable=false;
			TxtFld.multiline=false;

			TxtFld.antiAliasType=AntiAliasType.ADVANCED;

			var TF:TextFormat=new TextFormat();

			var FontC=getDefinitionByName(XMLObj.Numbers.@FontId) as Class;
			var newFont:Font=new FontC();

			TF.font=newFont.fontName;
			TF.size=XMLObj.Numbers.@FontSize;
			TF.color=XMLObj.Numbers.@FontColor;
			TF.align=TextFormatAlign.CENTER;

			TxtFld.setTextFormat(TF);
			TxtFld.embedFonts=true;

			var sh:MovieClip=new MovieClip();
			sh.graphics.beginFill(0xffffff,0);
			sh.graphics.drawRect(2,6,TxtFld.textWidth,TxtFld.textHeight-10);
			sh.graphics.endFill();

			mc.addChild(sh);
			mc.addChild(TxtFld);

			TxtFld.mouseEnabled=false;
			mc.hitArea=sh;
			mc.mouseChildren=false;
			mc.buttonMode=true;
			return mc;
		}

		private function Duplicate(drag:MovieClip):MovieClip {
			var mc:MovieClip=CreateMC(""+drag.index);
			mc.index=0;
			numContainer.addChild(mc);
			mc.x=drag.x;
			mc.y=drag.y;
			mc.xpos=mc.x;
			mc.ypos=mc.y;

			mc.mouseChildren=false;
			mc.buttonMode=true;
			mc.addEventListener(MouseEvent.MOUSE_DOWN,DragDuplicate);
			return mc;
		}
		private function DragIt(e:MouseEvent):void {
			var tar:MovieClip =e.currentTarget as MovieClip;
			if(digitsType=="all"){
				DragObj=Duplicate(tar);
			}else{
				//DragObj = tar;
				DragObj=Duplicate(tar);
			}
			if(tar.cnt < 1)
			{
				DragObj.x += rangeContainer.x;
				DragObj.startDrag(false,new Rectangle(0,0,sw-DragObj.width,sh-DragObj.height));	
				DragObj.addEventListener(MouseEvent.MOUSE_UP,DropIt);
				stage.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			}
			else
			{
				fnRemoveObj(tar);
			}
		}
		private function DragDuplicate(e:MouseEvent):void 
		{
			trace("DragDuplicate")
			var tar:MovieClip = e.currentTarget as MovieClip;
			fnRemoveObj(tar);
		}
		private function DropIt(e:MouseEvent):void {
			if (DragObj) 
			{
				DragObj.stopDrag();
				DragObj.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				stage.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				var cnt:Number=0;

				var _white=getChildByName("_white");
				for (var i:int=0; i<DropObjArray.length; i++) 
				{
					if (DragObj.hitTestObject(DropObjArray[i]))
					{						
							if(DropElementsArray[i].DropsArray.length < rCnt || DropElementsArray[i].DropsRemArray.length > 0 )
							{							
								if(DropElementsArray[i].DropsRemArray.length < 1 )
								{
									DragObj.x = dropsContainer.x + DropObjArray[i].x + (DropObjArray[i].width/2 - DragObj.width/2);
									var len:Number = DropElementsArray[i].DropsArray.length;
									var yPos:Number = Number(XMLObj.Table[tb].Columns1.@ypos) + Number(XMLObj.CommonColumnProperties.@headerheight) + (XMLObj.CommonColumnProperties.@columnHeight*len) + 10;
									DragObj.y = yPos;
									cnt++;
									DropElementsArray[i].DropsArray.push(DragObj);
									var pos:String = DragObj.x + "_" + DragObj.y;
									DragObj.cnt++;
									DropElementsArray[i].DropsPosArray.push(pos);
									DragObj.index = DropElementsArray[i].DropsArray.length - 1;
									
									// for random numbers
									if(digitsType!="all")
									{
										trace("dropped if")
										droppedObjArr.push(DragObj);
										var rem:Number = 0;
										if(indx==0)
										{
											rem = droppedObjArr.length%4;
										}
										else{
											rem = droppedObjArr.length%3;
										}
										if(rem == 0)
										{
											for(var ik:int = 0; ik < droppedObjArr.length; ik++)
											{
												var clip:MovieClip = droppedObjArr[ik];
												//clip.enabled = false;
												//clip.mouseEnabled = false;
												//clip.removeEventListener(MouseEvent.MOUSE_DOWN,DragIt);
											}
											if(rCnt < 6)
											{
												rCnt++;
											}
											
											trace("rCnt "+rCnt)
											if(rCnt <= Number(XMLObj.Table[tb].Rows.@count))
											{
												flag = false;
												CreateTable();
												//removeDigits();
												//CreateDrags();
												CreateDrops();
											}
										}
									}
								}
								else
								{
									trace("dropped else")
									if(digitsType!="all")
									{
										droppedObjArr.push(DragObj);
									}
									var ind:Number = DropElementsArray[i].DropsRemArray[0];
									var arrPos:Array = DropElementsArray[i].DropsPosArray[ind].split("_");
									DragObj.x = Number(arrPos[0]);
									DragObj.y = Number(arrPos[1]);
									DropElementsArray[i].DropsArray[ind] = DragObj;
									cnt++;
									DragObj.cnt++;
									DragObj.index = ind;
									DropElementsArray[i].DropsRemArray.splice(0,1);
								}
								break;
							}
						}
					
				}
				try
				{
					if (cnt==0) 
					{
						trace("came")
						numContainer.removeChild(DragObj);
					}
					
				} catch (e:Error) {
					if(cnt==0 && digitsType!="all"){
						/*DragObj.x = DragObj.xpos;
						DragObj.y = DragObj.ypos;*/
					}
				}
			}
		}
		
		//removed drag element from table when it is clicked
		private function fnRemoveObj(e:MovieClip):void{
			var dragObj:MovieClip = e;
			var ind:Number = dragObj.dropTarget.name.split("_")[1];
			DropElementsArray[ind].DropsRemArray.push(dragObj.index);
			
			/*if(digitsType!="all")
			{
				dragObj.x = dragObj.xpos;
				dragObj.y = dragObj.ypos;
				dragObj.cnt = 0;	
				for(var i:int = 0; i < droppedObjArr.length; i++)
				{
					droppedObjArr[i] = dragObj;
					droppedObjArr.splice(i,1);
					break;
				}
			}
			else{*/
			for(var i = 0; i < droppedObjArr.length; i++)
			{
				if(droppedObjArr[i] == dragObj)
				{
					droppedObjArr.splice(i,1);
					i--;
				}
			}
				numContainer.removeChild(dragObj);
			/*}*/
		}
		
		private function Reset(e:MouseEvent):void {
			for (var i:int=0; i<RowObjectsArray.length; i++) {
				for (var m:int=RowObjectsArray[i].RowArray.length; m>=0; m--) {
					try {
						if (RowObjectsArray[i].RowArray[m]) {
							removeChild(RowObjectsArray[i].RowArray[m]);
						}
					} catch (e:Error) {

					}
				}
				RowObjectsArray[i].RowArray=new Array();
				DropElementsArray[i].DropsArray=new Array();
				DropElementsArray[i].DropsPosArray = new Array();
				DropElementsArray[i].DropsRemArray = new Array();
			}
		}
		private function CreateMab() {
			clearMabObj();
			for (var i=1; i<=4; i++) {
				var mb:MovieClip;
				switch (i) {
					case 1 :
						mb=new object1();
						mb.x=730;
						mb.y=460;
						break;
					case 2 :
						mb=new object2();
						mb.x=673;
						mb.y=460;
						break;
					case 3 :
						mb=new object3();
						mb.x=640;
						mb.y=460;
						break;
					case 4 :
						mb=new object4();
						mb.x=625;
						mb.y=465;
						break;
				}
				mb.name="mab"+i;

				
				mb.addEventListener(MouseEvent.MOUSE_DOWN, dragMabObj);
				mb.doubleClickEnabled=true;
				mb.addEventListener(MouseEvent.DOUBLE_CLICK, removeMabObj);
				mabContainer.addChild(mb);
			}
			toggleMabObj();

		}

		private function toggleMabObj() {
			if (showMABBtn.currentFrame==2) {
				mabContainer.visible=true;
			} else {
				mabContainer.visible=false;
			}
		}
		function dragMabObj(e:MouseEvent) {
			if (e.target.name!="") {
				var newMab:MovieClip;
				switch (e.target.name) {
					case "mab1" :
						newMab=new object1();
						break;
					case "mab2" :
						newMab=new object2();
						break;
					case "mab3" :
						newMab=new object3();
						break;
					case "mab4" :
						newMab=new object4();
						break;
				}
				var objName=e.target.name;
				e.target.name="";
				newMab.name=objName;
				newMab.x=e.target.x;
				newMab.y=e.target.y;
				newMab.addEventListener(MouseEvent.MOUSE_DOWN, dragMabObj);
				newMab.doubleClickEnabled=true;
				newMab.addEventListener(MouseEvent.DOUBLE_CLICK, removeMabObj);
				mabContainer.addChild(newMab);
			}

			e.target.startDrag(false,new Rectangle(0,0,sw-e.target.width,sh-e.target.height));
			e.target.addEventListener(MouseEvent.MOUSE_UP, dropMabObj);

		}

		function dropMabObj(e:MouseEvent) {
			e.target.stopDrag();
		}
		function clearMabObj() {
			while (mabContainer.numChildren>0) {
				mabContainer.removeChildAt(0);
			}

		}
		function removeMabObj(e:MouseEvent) {

			mabContainer.removeChild(MovieClip(e.target));
		}
		function reset(e:MouseEvent) {
			tb=0;
			//digitsType="all";
			if (digitsType=="all") {
				rCnt=Number(XMLObj.Table[tb].Rows.@count);
			}else{
				rCnt = 1;
			}
			flag = true;
			removeDigits();
			initialize();
			CreateMab();
		}

	}
}